# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
include:
- template: Code-Quality.gitlab-ci.yml
- template: Security/SAST.gitlab-ci.yml

# security test job
sast:
  variables:
    SAST_EXCLUDED_PATHS: spec, test, tests, tmp, unittests
    SEARCH_MAX_DEPTH: '10'

test_py3.9_linux:
  image: python:3.9
  needs:
    - job: code_quality
    - job: bandit-sast
  script:
  - pytest -x -n0 -k "not CodeQualityTest"
  coverage: "/^TOTAL\\s+\\d+\\s+\\d+\\s+(\\d+)\\%\\s*$/"
  before_script:
  - python --version
  - pip install -r requirements.txt
  - pip install -r test-requirements.txt
  - pip install .

code_quality:
  image: python:3.9
  script:
  - pytest -k CodeQualityTest
  before_script:
  - python --version
  - pip install -r requirements.txt
  - pip install -r test-requirements.txt
  - pip install .
  artifacts:
    paths:
    - gl-code-quality-report.json

test_doc_build:
  image: python:3.9
  needs:
    - job: test_py3.9_linux
  script:
  - cd doc
  - make clean
  - make html
  before_script:
  - python --version
  - pip install -r requirements.txt
  - pip install -r docs-requirements.txt
  - pip install .
  - mkdir doc/source/_static
  allow_failure: 

pages:
  needs:
  - job: test_doc_build
  image: python:3.9
  script:
  - cd doc
  - make html
  - mv build/html ../public
  artifacts:
    paths:
    - public
  only:
  - master
  before_script:
  - python --version
  - pip install -r requirements.txt
  - pip install -r docs-requirements.txt
  - pip install .
  - mkdir doc/source/_static

